1000 '------- robot cleaner -------
1010 '     for PC-8001 N-BASIC
1020 '    Ayaori Tohno 2015.5.7
1030 '-----------------------------
1040 WIDTH 40,25:CONSOLE 0,25,0,1
1050 DEFINT A-Z
1060 DEF FNSS(X,Y)=PEEK(&HF302+X*2+Y*120)
1070 DEF FNWN(X,Y)=-((Y=-1)+(Y=1)*2+(X=-1)*3+(X=1)*4)
1080 DEF FNGX(N)=(N=3)-(N=4)
1090 DEF FNGY(N)=(N=1)-(N=2)
1100 DEF FNBI(A)=-(A=0)+(A>0)*((A>0)+(A>20)+(A>40)+(A>60)+(A>80)+(A>95)*5-1)
1110 FALSE=0:TRUE=NOT FALSE
1120 KABE=219:ROBO=236:BASE=66:CAT=64:DIRT=35:BLANK=32
1130 BB$=STRING$(5," ")+STRING$(5,142)+" FULL"
1140 DIM WC(4),CF(2)
1150 '------- init game -------
1160 RD=1
1170 '------- demo -------
1180 PRINT CHR$(12)
1190 COLOR 4:LOCATE  9, 4:PRINT "*  ROBOT  CLEARNER  *"
1200 COLOR 7:LOCATE 12, 7:PRINT CHR$(ROBO);" ... R.CLEARNER"
1210 COLOR 2:LOCATE 12, 9:PRINT CHR$(CAT );" ... CAT"
1220 COLOR 5:LOCATE 12,10:PRINT CHR$(DIRT);" ... DIRT"
1230 COLOR 6:LOCATE 12,12:PRINT CHR$(BASE);" ... RECHARGE"
1240         LOCATE 12,13:PRINT           "      BASE"
1250 COLOR 7
1260 LOCATE 24,16:PRINT "8"
1270 LOCATE 24,17:PRINT "^"
1280 LOCATE 13,18:PRINT "CONTROL  4<";CHR$(ROBO);">6"
1290 LOCATE 24,19:PRINT "v"
1300 LOCATE 24,20:PRINT "2"
1310 COLOR 2:LOCATE 15,22:PRINT "PRESS[RET]"
1320 IF INP(1)=127 THEN 1340 ELSE 1320
1330 '------- init round -------
1340 RX=20:RY=16:DX= 0:DY=0:BT=100-(RD-1)*20:BF=FALSE
1350 CX=20:CY= 8:EX=-1:EY=0
1360 GOSUB 2160 '*make screen
1370 '------- robot move -------
1380 K0=INP(0):K1=INP(1)
1390 XX=(K0=239)-(K0=191):YY=(K1=254)-(K0=251)
1400 IF XX<>0 OR YY<>0 THEN DX=XX:DY=YY:BF=FALSE
1410 C=FNSS(RX+DX,RY+DY)
1420 IF C=BASE THEN DX=0:DY=0:BF=TRUE
1430 IF C=KABE THEN DX=0:DY=0
1440 IF C=DIRT THEN DP=DP-1
1450 IF DX=0 AND DY=0 THEN 1500
1460   COLOR 7:LOCATE RX+DX,RY+DY:PRINT CHR$(ROBO);
1470   COLOR 1:LOCATE RX   ,RY   :PRINT CHR$(BLANK);
1480   RX=RX+DX:RY=RY+DY
1490 '
1500 IF DP<=0 THEN 1950 '*roundclear
1510 '       battery inc & dec
1520 D=-1:C=6:IF BF THEN D=4:C=2
1530 BT=BT+D:IF BT>100 THEN BT=100
1540 COLOR C:LOCATE 34,11:PRINT MID$(BB$,FNBI(BT),5);
1550 IF BT<=0 THEN 2010 '*gameover
1560 '------- cat move -------
1570 N=FNWN(-EX,-EY)
1580 WAY=0
1590 FOR I=1 TO 4
1600   IF I=N THEN 1640
1610     X=FNGX(I):Y=FNGY(I)
1620     C=FNSS(CX+X,CY+Y)
1630     IF C<>KABE AND C<>BASE THEN WAY=WAY+1:WC(WAY)=I
1640 NEXT
1650 '       
1660 IF WAY=1 THEN R=1:GOTO 1790
1670   A=RND(1)*3
1680   IF A=1 THEN 1780 ' random walk
1690     X=FNWN(SGN(RX-CX),0):Y=FNWN(0,SGN(RY-CY))
1700     CF(1)=X:CF(2)=Y
1710     IF ABS(RX-CX)>ABS(RY-CY) THEN CF(1)=Y:CF(2)=X
1720     R=0
1730     FOR I=1 TO 2
1740       FOR J=1 TO WAY
1750          IF CF(I)=WC(J) THEN R=J
1760     NEXT J,I
1770     IF R<>0 THEN 1790
1780   R=(RND(1)*WAY)+1
1790 EX=FNGX(WC(R)):EY=FNGY(WC(R))
1800 '
1810 DF=FALSE
1820 IF FNSS(CX+EX,CY+EY)=DIRT THEN DF=TRUE
1830 COLOR 2:LOCATE CX+EX,CY+EY:PRINT CHR$(CAT);
1840 A=BLANK:C=1:IF DC>0 THEN A=DIRT:C=5:DC=DC-1
1850 COLOR C:LOCATE CX   ,CY   :PRINT CHR$(A);
1860 CX=CX+EX:CY=CY+EY
1870 '       catch
1880 IF CX=RX AND CY=RY THEN 2010
1890 '       dirt
1900 IF DF THEN DC=DC+2:DP=DP+1
1910 IF DP>DL THEN DP=DL:DC=DC-1
1920 '
1930 GOTO 1380
1940 '------- round clear -------
1950 COLOR 7:LOCATE 14,11:PRINT "   CLEAR!   "
1960         LOCATE 14,12:PRINT " PRESS[SPC] "
1970 RD=RD+1
1980 IF INP(9)<>191 THEN 1980
1990   IF RD>3 THEN 2050 ELSE 1340
2000 '------- game over -------
2010 COLOR 7:LOCATE 14,11:PRINT "  GAMEOVER  "
2020         LOCATE 14,12:PRINT " PRESS[SPC] "
2030 IF INP(9)=191 THEN 1160 ELSE 2030
2040 '------- clear! -------
2050 PRINT CHR$(12)
2060 C$=" CONGRATULATIONS!  "
2070 FOR I=1 TO 19
2080   COLOR 7:LOCATE 30-I,11:PRINT CHR$(ROBO);
2090   COLOR 6:LOCATE 31-I,11:PRINT RIGHT$(C$,I);
2100   FOR T=1 TO 300:NEXT
2110 NEXT
2120 '
2130 COLOR 4:LOCATE 15,18:PRINT "PRESS[SPC]"
2140 IF INP(9)=191 THEN 1160 ELSE 2140
2150 '----- make screen -----
2160 PRINT CHR$(12)
2170 COLOR 6
2180 LOCATE 1, 5:PRINT "ROBOT***"
2190 LOCATE 1, 6:PRINT "*CLEANER"
2200 COLOR 4
2210 LOCATE 1,15:PRINT "AYAORI"
2220 LOCATE 1,16:PRINT "  TOHNO"
2230 LOCATE 1,17:PRINT "    2015"
2240 COLOR 7
2250 LOCATE 32, 9:PRINT "BATTERY"
2260 LOCATE 32,14:PRINT "  ROUND"
2270 LOCATE 37,16:PRINT RD;
2280 '
2290 RESTORE 2560
2300 COLOR 1
2310 DL=0
2320 FOR I=2 TO 22
2330   READ D$
2340   FOR J=1 TO 20
2350      C$=MID$(D$,J,1):DL=DL+1
2360      IF C$<>CHR$(BLANK) THEN C$=CHR$(KABE):DL=DL-1
2370      LOCATE 9+J,I:PRINT C$;
2380   NEXT
2390 NEXT
2400 DL=DL/2 ' dirt limit
2410 '
2420 COLOR 6:LOCATE 29,12:PRINT CHR$(BASE);
2430         LOCATE 10,12:PRINT CHR$(BASE);
2440 COLOR 7:LOCATE RX,RY:PRINT CHR$(ROBO);
2450 COLOR 2:LOCATE CX,CY:PRINT CHR$(CAT );
2460 '
2470 DT=3+RD*9:DP=0
2480 FOR I=1 TO DT
2490   X=(RND(1)*18)+11:Y=(RND(1)*19)+3
2500   IF FNSS(X,Y)<>BLANK THEN 2490
2510   COLOR 5:LOCATE X,Y:PRINT CHR$(DIRT);
2520   DP=DP+1
2530 NEXT
2540 RETURN
2550 '----- stage data -----
2560 DATA "MMMMMMMMMMMMMMMMMMMM"
2570 DATA "M        MM        M"
2580 DATA "M MM MMM MM MMM MM M"
2590 DATA "M MM MMM    MMM MM M"
2600 DATA "M      MMMMMM      M"
2610 DATA "MMM MM MMMMMM MM MMM"
2620 DATA "MMM MM        MM MMM"
2630 DATA "MMM MM MMMMMM MM MMM"
2640 DATA "M             MM   M"
2650 DATA "M MMMM MMMMMM MMMM M"
2660 DATA "M MMMM        MMMM M"
2670 DATA "M MMMM MMMMMM MMMM M"
2680 DATA "M   MM             M"
2690 DATA "MMM MM MMMMMM MM MMM"
2700 DATA "MMM MM        MM MMM"
2710 DATA "MMM MM MMMMMM MM MMM"
2720 DATA "M      MMMMMM      M"
2730 DATA "M MM MMM    MMM MM M"
2740 DATA "M MM MMM MM MMM MM M"
2750 DATA "M        MM        M"
2760 DATA "MMMMMMMMMMMMMMMMMMMM"
